//*******************************************************************************************************************
//
//@MPL-36-01v2.00/USBW32 Dynamic Link Library Structure, Function Declarations		5.3601.11.1310
//
//*******************************************************************************************************************
//
//*** DEFINITION ***
#define MC07_USB_UNIT_0             0x2000
#define MC07_USB_UNIT_1             0x2001
#define MC07_USB_UNIT_2             0x2002
#define MC07_USB_UNIT_3             0x2003
#define MC07_USB_UNIT_4             0x2004
#define MC07_USB_UNIT_5             0x2005
#define MC07_USB_UNIT_6             0x2006
#define MC07_USB_UNIT_7             0x2007
#define MC07_USB_UNIT_8             0x2008
#define MC07_USB_UNIT_9             0x2009

#define MC07_X						0
#define MC07_Y						1
#define MC07_Z						2
#define MC07_A						3

#define MC07_EX_UNIT_COMM_RATE_5    2

#define MC07_EX_UNIT_COMM_16BIT     0
#define MC07_EX_UNIT_COMM_32BIT     1

#define MC07_EX_UNIT_COMM_START             0
#define MC07_EX_UNIT_COMM_STOP              1
#define MC07_EX_UNIT_COMM_DISC_LATCH_CLR    2

#define MC07_STATUS1				0
#define MC07_STATUS2				1
#define MC07_STATUS3				2
#define MC07_STATUS4				3
#define MC07_STATUS5				4
#define MC07_ORG_STATUS				5

#define MC07_GP_IN					0x0
#define MC07_GP_OUT					0x1
#define MC07_EXP0_IN				0x2
#define MC07_EXP1_IN				0x3
#define MC07_EXP0_OUT				0x4
#define MC07_EXP1_OUT				0x5
#define MC07_CTLP0_IN				0x6
#define MC07_CTLP0_OUT				0x7

#define MC07_ORG0					0
#define MC07_ORG1					1
#define MC07_ORG2					2
#define MC07_ORG3					3
#define MC07_ORG4					4
#define MC07_ORG5					5
#define MC07_ORG10					10
#define MC07_ORG11					11
#define MC07_ORG12					12

#define MC07_CCW					0
#define MC07_CW						1

#define MC07_SEL_X                  0x00000001
#define MC07_SEL_Y                  0x00000002
#define MC07_SEL_Z                  0x00000004
#define MC07_SEL_A                  0x00000008
#define MC07_SEL_X_Y                0x00000003
#define MC07_SEL_X_Z                0x00000005
#define MC07_SEL_X_A                0x00000009
#define MC07_SEL_Y_Z                0x00000006
#define MC07_SEL_Y_A                0x0000000a
#define MC07_SEL_Z_A                0x0000000c
#define MC07_SEL_X_Y_Z              0x00000007
#define MC07_SEL_X_Y_A              0x0000000b
#define MC07_SEL_X_Z_A              0x0000000d
#define MC07_SEL_Y_Z_A              0x0000000e
#define MC07_SEL_X_Y_Z_A            0x0000000f

#define MC07_SEL_GP_OUT             0x00000001
#define MC07_SEL_EXP0_OUT           0x00000004
#define MC07_SEL_EXP1_OUT           0x00000008
#define MC07_SEL_CTLP0_OUT          0x00000002
#define MC07_SEL_EXP0_EXP1_OUT      0x0000000c

#define MC07_SEL_GP_IN              0x00010000
#define MC07_SEL_EXP0_IN            0x00040000
#define MC07_SEL_EXP1_IN            0x00080000
#define MC07_SEL_CTLP0_IN           0x00020000
#define MC07_SEL_EXP0_EXP1_IN       0x000c0000

//*** RESULT STRUCTURE ***
typedef struct MC07_TAG_S_RESULT {
	WORD			MC07_Result[4];
} MC07_S_RESULT;

//*** COMMAND DATA STRUCTURE ***
typedef struct _MC07_S_COMMAND_DATA {
    WORD            Command;
    DWORD           Data;
} MC07_S_COMMAND_DATA;

//*** STATUS DATA STRUCTURE ***
typedef struct _MC07_S_STATUS_DATA {
	WORD            Status1;
    DWORD           Data;
} MC07_S_STATUS_DATA;

//*** UNIT INFO STRUCTURE ***
typedef struct _MC07_S_UNIT_INFO{
	WORD			UnitType[10];
}MC07_S_UNIT_INFO;

//*** COMMAND BUFFER STRUCTURE ***
typedef struct _MC07_S_COMMAND_BUF {
	WORD			Command[16];
} MC07_S_COMMAND_BUF;

//*** DATA BUFFER STRUCTURE ***
typedef struct _MC07_S_DATA_BUF {
	DWORD			Data[16];
} MC07_S_DATA_BUF;

//*** STATUS BUFFER STRUCTURE ***
typedef struct _MC07_S_STATUS_BUF {
	WORD			Status[16];
} MC07_S_STATUS_BUF;

//*** DATA STRUCTURE ***
typedef struct _MC07_S_DATA {
    WORD            MC07_Data[4];
} MC07_S_DATA;

//*** SPEED RATE STRUCTURE ***
typedef struct _MC07_S_SPEED_RATE {
	DWORD			FSpd;
	DWORD			HighSpeed;
	DWORD			LowSpeed;
	DWORD			EndLowSpeed;
	DWORD			SUArea;
	DWORD			SDArea;
	DWORD			URateNo;
	DWORD			DRateNo;
} MC07_S_SPEED_RATE;

//*** XY POSITION STRUCTURE ***
typedef struct _MC07_S_XY_POSITION {
	LONG			X;
	LONG			Y;
} MC07_S_XY_POSITION;

//*** ORG PARAMETER STRUCTURE ***
typedef struct _MC07_S_ORG_PARAM {
	DWORD			Spec;
	DWORD			MarginPulse;
	DWORD			LimitDelay;
	DWORD			ScanDelay;
	DWORD			PulseDelay;
	DWORD			CScanErrorPulse;
	DWORD			PulseErrorPulse;
	DWORD			OffsetPulse;
	LONG			PresetPulse;
} MC07_S_ORG_PARAM;

/*** A/D DATA STRUCTURE ***/
typedef struct _MC07_S_AD_DATA {
	WORD			Data[16];
} MC07_S_AD_DATA;

/*** IN PORT STRUCTURE ***/
typedef struct _MC07_S_IN_PORT {
    WORD            Gpin;
    WORD            Gp0in;
    WORD            Gp1in;
    WORD            Exp0in;
    WORD            Exp1in;
    WORD            Ctlp0in;
} MC07_S_IN_PORT;

/*** OUT PORT STRUCTURE ***/
typedef struct _MC07_S_OUT_PORT {
    WORD            Gpout;
    WORD            Gp0out;
    WORD            Gp1out;
    WORD            Exp0out;
    WORD            Exp1out;
    WORD            Ctlp0out;
} MC07_S_OUT_PORT;

/*** UNIT STATUS STRUCTURE ***/
typedef struct _MC07_S_UNIT_STATUS {
    MC07_S_STATUS_DATA  X;
    MC07_S_STATUS_DATA  Y;
    MC07_S_STATUS_DATA  Z;
    MC07_S_STATUS_DATA  A;
    MC07_S_IN_PORT      InPort;
} MC07_S_UNIT_STATUS;

/*** UNIT COMMAND STRUCTURE ***/
typedef struct _MC07_S_UNIT_COMMAND {
    MC07_S_COMMAND_DATA X;
    MC07_S_COMMAND_DATA Y;
    MC07_S_COMMAND_DATA Z;
    MC07_S_COMMAND_DATA A;
    MC07_S_OUT_PORT     OutPort;
} MC07_S_UNIT_COMMAND;

/*** Function Prototype Declarations Exported ***/
#if !defined(_USBFUNC_)
    #define USB_API    __declspec( dllimport )
#else
    #define USB_API    __declspec( dllexport )
#endif

#ifdef __cplusplus
extern"C"{
#endif

USB_API BOOL WINAPI MC07_Environment( WORD UnitNo, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_ReadUnitInfo( WORD UnitNo, MC07_S_UNIT_INFO *psUnitInfo, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UOpen( WORD UnitNo, DWORD *phUnit, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UClose( DWORD hUnit, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UClrError( DWORD hUnit, DWORD AxisSel, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UWExUnitCommMode( DWORD hUnit, WORD CommRate, WORD RetryCount, WORD IoBit, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UWExUnitCommControl( DWORD hUnit, WORD ControlSel, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_URExUnitCommStatus( DWORD hUnit, WORD *pStatus, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_URExUnitCommMode( DWORD hUnit, WORD *pCommRate, WORD *pRetryCount, WORD *pIoBit, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRADData( DWORD hUnit, WORD Signal, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_IRADData( DWORD hUnit, MC07_S_AD_DATA *psData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UWDriveIo( DWORD hUnit, DWORD AxisSel, DWORD IoPortSel, MC07_S_UNIT_COMMAND *psUnitCmd, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UWRDrive( DWORD hUnit, DWORD AxisSel, MC07_S_UNIT_COMMAND *psUnitCmd, MC07_S_UNIT_STATUS *psUnitStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_URStatus1Io( DWORD hUnit, DWORD AxisSel, DWORD IoPortSel, MC07_S_UNIT_STATUS *psUnitStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_URStatus1PcntIo( DWORD hUnit, DWORD AxisSel, DWORD IoPortSel, MC07_S_UNIT_STATUS *psUnitStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UPortOut( DWORD hUnit, DWORD IoPortSel, MC07_S_OUT_PORT *psOutPort, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UPortOrOut( DWORD hUnit, DWORD IoPortSel, MC07_S_OUT_PORT *psOutPort, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UPortAndOut( DWORD hUnit, DWORD IoPortSel, MC07_S_OUT_PORT *psOutPort, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_UPortIn( DWORD hUnit, DWORD IoPortSel, MC07_S_IN_PORT *psInPort, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BOpen( WORD UnitNo, WORD Axis, DWORD *phDev, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BClose( DWORD hDev, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_ClrError( DWORD hDev, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BufWDrive( DWORD hDev, MC07_S_COMMAND_BUF *psCmdBuf, MC07_S_DATA_BUF *psDataBuf, WORD Count, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_LWDrive( DWORD hDev, WORD Cmd, DWORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_LWData( DWORD hDev, DWORD *pData, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_IWDrive( DWORD hDev, WORD Cmd, MC07_S_DATA *psData, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_IWData( DWORD hDev, MC07_S_DATA *psData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_LWDriveBuf( DWORD hDev, MC07_S_COMMAND_DATA CmdDataBuf[], WORD Count, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_BWDriveCommand( DWORD hDev, WORD *pCmd, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BWDriveData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BWDriveData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_AllRStatus( DWORD hDev, MC07_S_STATUS_BUF *psStsBuf, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRStatus1( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRStatus2( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRStatus3( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRStatus4( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRStatus5( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRStatusBuf( DWORD hDev, WORD StatusBuf[], MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_LRDrive( DWORD hDev, DWORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_IRDrive( DWORD hDev, MC07_S_DATA *psData, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_BRDriveData1( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BRDriveData2( DWORD hDev, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_LWRDrive( DWORD hDev, WORD Cmd, DWORD *pWriteData, DWORD *pReadData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BWaitDriveCommand( DWORD hDev, WORD WaitTime, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BWaitComregNotFull( DWORD hDev, WORD WaitTime, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BIsWait( DWORD hDev, WORD *pWaitSts, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BBreakWait( DWORD hDev, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetSpeedRate( DWORD hDev, WORD ResolNo, MC07_S_SPEED_RATE *psSpeedRate, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_ReadSpeedRate( DWORD hDev, WORD *pResolNo, MC07_S_SPEED_RATE *psSpeedRate, MC07_S_RESULT *psResult);
USB_API BOOL WINAPI MC07_McIncStrCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, MC07_S_XY_POSITION *psTargetPosition, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_McIncCirCp( DWORD hDevX, DWORD hDevY, WORD DrvSpec, WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTargetPosition, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_GetCirShortPulse( WORD Dir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_XY_POSITION *psTargetPosition, LONG *pShortPulse, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_GetCirCenterPosition( MC07_S_XY_POSITION *psPassPosition, MC07_S_XY_POSITION *psTargetPosition, WORD *pDir, MC07_S_XY_POSITION *psCenterPosition, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_IncFromAbs( DWORD hDevX, DWORD hDevY, MC07_S_XY_POSITION *psAbsPosition, MC07_S_XY_POSITION *psIncPosition, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_ReadOrgStatus( DWORD hDev, WORD *pStatus, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetOrgSpec( DWORD hDev, WORD Spec, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetOrgMarginPulse( DWORD hDev, DWORD MarginPulse, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetOrgDelay( DWORD hDev, WORD LimitDelay, WORD ScanDelay, WORD PulseDelay, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetOrgErrorPulse( DWORD hDev, DWORD CscanErrorPulse, DWORD PulseErrorPulse, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetOrgOffsetPulse( DWORD hDev, DWORD OffsetPulse, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_SetOrgPresetPulse( DWORD hDev, LONG PresetPulse, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_ReadOrgParam( DWORD hDev, MC07_S_ORG_PARAM *psOrgParam, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_ResetOrgFlag( DWORD hDev, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_Org( DWORD hDev, WORD OrgType, MC07_S_RESULT *psResult );
USB_API VOID WINAPI MC07_SetData( DWORD Data, MC07_S_DATA *psData );
USB_API DWORD WINAPI MC07_GetData( MC07_S_DATA *psData );
USB_API BOOL WINAPI MC07_BPortOpen( WORD UnitNo, WORD IoPort, DWORD *phPort, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BPortClose( DWORD hPort, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BPortOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BPortOrOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BPortAndOut( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
USB_API BOOL WINAPI MC07_BPortIn( DWORD hPort, WORD *pData, MC07_S_RESULT *psResult );
USB_API WORD WINAPI MC07_Unsigned16( SHORT Data );
USB_API SHORT WINAPI MC07_Signed16( WORD Data );
USB_API DWORD WINAPI MC07_Unsigned32( LONG Data );
USB_API LONG WINAPI MC07_Signed32( DWORD Data );
#ifdef __cplusplus
}
#endif
