Attribute VB_Name = "USBC"
 Option Explicit

'*************************************************************************************************************************
'
'@MPL-36-01v2.00/USBW32 Dynamic Link Library Structure, Function Declarations              5.3601.10.1310
'
'*************************************************************************************************************************

'*** DEFINITION ***
Public Const MC07_USB_UNIT_0 As Integer = &H2000
Public Const MC07_USB_UNIT_1 As Integer = &H2001
Public Const MC07_USB_UNIT_2 As Integer = &H2002
Public Const MC07_USB_UNIT_3 As Integer = &H2003
Public Const MC07_USB_UNIT_4 As Integer = &H2004
Public Const MC07_USB_UNIT_5 As Integer = &H2005
Public Const MC07_USB_UNIT_6 As Integer = &H2006
Public Const MC07_USB_UNIT_7 As Integer = &H2007
Public Const MC07_USB_UNIT_8 As Integer = &H2008
Public Const MC07_USB_UNIT_9 As Integer = &H2009

Public Const MC07_X As Integer = 0
Public Const MC07_Y As Integer = 1
Public Const MC07_Z As Integer = 2
Public Const MC07_A As Integer = 3

Public Const MC07_EX_UNIT_COMM_RATE_5 As Integer = 2

Public Const MC07_EX_UNIT_COMM_16BIT As Integer = 0
Public Const MC07_EX_UNIT_COMM_32BIT As Integer = 1

Public Const MC07_EX_UNIT_COMM_START As Integer = 0
Public Const MC07_EX_UNIT_COMM_STOP As Integer = 1
Public Const MC07_EX_UNIT_COMM_DISC_LATCH_CLR As Integer = 2

Public Const MC07_STATUS1 As Integer = 0
Public Const MC07_STATUS2 As Integer = 1
Public Const MC07_STATUS3 As Integer = 2
Public Const MC07_STATUS4 As Integer = 3
Public Const MC07_STATUS5 As Integer = 4
Public Const MC07_ORG_STATUS As Integer = 5

Public Const MC07_GP_IN As Integer = &H0
Public Const MC07_GP_OUT As Integer = &H1
Public Const MC07_EXP0_IN As Integer = &H2
Public Const MC07_EXP1_IN As Integer = &H3
Public Const MC07_EXP0_OUT As Integer = &H4
Public Const MC07_EXP1_OUT As Integer = &H5
Public Const MC07_CTLP0_IN As Integer = &H6
Public Const MC07_CTLP0_OUT As Integer = &H7

Public Const MC07_ORG0 As Integer = 0
Public Const MC07_ORG1 As Integer = 1
Public Const MC07_ORG2 As Integer = 2
Public Const MC07_ORG3 As Integer = 3
Public Const MC07_ORG4 As Integer = 4
Public Const MC07_ORG5 As Integer = 5
Public Const MC07_ORG10 As Integer = 10
Public Const MC07_ORG11 As Integer = 11
Public Const MC07_ORG12 As Integer = 12

Public Const MC07_CCW As Integer = 0
Public Const MC07_CW As Integer = 1

Public Const MC07_SEL_X As Long = &H1
Public Const MC07_SEL_Y As Long = &H2
Public Const MC07_SEL_Z As Long = &H4
Public Const MC07_SEL_A As Long = &H8
Public Const MC07_SEL_X_Y As Long = &H3
Public Const MC07_SEL_X_Z As Long = &H5
Public Const MC07_SEL_X_A As Long = &H9
Public Const MC07_SEL_Y_Z As Long = &H6
Public Const MC07_SEL_Y_A As Long = &HA
Public Const MC07_SEL_Z_A As Long = &HC
Public Const MC07_SEL_X_Y_Z As Long = &H7
Public Const MC07_SEL_X_Y_A As Long = &HB
Public Const MC07_SEL_X_Z_A As Long = &HD
Public Const MC07_SEL_Y_Z_A As Long = &HE
Public Const MC07_SEL_X_Y_Z_A As Long = &HF

Public Const MC07_SEL_GP_OUT = &H1
Public Const MC07_SEL_EXP0_OUT = &H4
Public Const MC07_SEL_EXP1_OUT = &H8
Public Const MC07_SEL_CTLP0_OUT = &H2
Public Const MC07_SEL_EXP0_EXP1_OUT = &HC

Public Const MC07_SEL_GP_IN = &H10000
Public Const MC07_SEL_EXP0_IN = &H40000
Public Const MC07_SEL_EXP1_IN = &H80000
Public Const MC07_SEL_CTLP0_IN = &H20000
Public Const MC07_SEL_EXP0_EXP1_IN = &HC0000

'*** RESULT STRUCTURE ***
Type MC07_S_RESULT
    MC07_Result(1 To 4) As Integer
End Type

'*** COMMAND DATA STRUCTURE ***
Type MC07_S_COMMAND_DATA
    Command As Integer
    Data As Long
End Type

'*** STATUS DATA STRUCTURE ***
Type MC07_S_STATUS_DATA
    Status1 As Integer
    Data As Long
End Type

'*** UNIT INFO STRUCTURE ***
Type MC07_S_UNIT_INFO
    UnitType(1 To 10) As Integer
End Type

'*** COMMAND BUFFER STRUCTURE ***
Type MC07_S_COMMAND_BUF
    Command(0 To 15) As Integer
End Type

'*** DATA BUFFER STRUCTURE ***
Type MC07_S_DATA_BUF
    Data(0 To 15) As Long
End Type

'*** STATUS BUFFER STRUCTURE ***
Type MC07_S_STATUS_BUF
    Status(0 To 15) As Integer
End Type

'*** DATA STRUCTURE ***
Type MC07_S_DATA
    MC07_Data(1 To 4) As Integer
End Type

'*** SPEED RATE STRUCTURE ***
Type MC07_S_SPEED_RATE
    FSpd As Long
    HighSpeed As Long
    LowSpeed As Long
    EndLowSpeed As Long
    SUArea As Long
    SDArea As Long
    URateNo As Long
    DRateNo As Long
End Type

'*** XY POSITION STRUCTURE ***
Type MC07_S_XY_POSITION
    X As Long
    Y As Long
End Type

'*** ORG PARAMETER STRUCTURE ***
Type MC07_S_ORG_PARAM
    Spec As Long
    MarginPulse As Long
    LimitDelay As Long
    ScanDelay As Long
    PulseDelay As Long
    CScanErrorPulse As Long
    PulseErrorPulse As Long
    OffsetPulse As Long
    PresetPulse As Long
End Type

'*** A/D DATA STRUCTURE ***
Type MC07_S_AD_DATA
    Data(1 To 16) As Integer
End Type

'*** IN PORT STRUCTURE ***
Type MC07_S_IN_PORT
    Gpin As Integer
    Gp0in As Integer
    Gp1in As Integer
    Exp0in As Integer
    Exp1in As Integer
    Ctlp0in As Integer
End Type

'*** OUT PORT STRUCTURE ***
Type MC07_S_OUT_PORT
    Gpout As Integer
    Gp0out As Integer
    Gp1out As Integer
    Exp0out As Integer
    Exp1out As Integer
    Ctlp0out As Integer
End Type

'*** UNIT STATUS STRUCTURE ***
Type MC07_S_UNIT_STATUS
    X As MC07_S_STATUS_DATA
    Y As MC07_S_STATUS_DATA
    Z As MC07_S_STATUS_DATA
    A As MC07_S_STATUS_DATA
    InPort As MC07_S_IN_PORT
End Type
    
'*** UNIT COMMAND STRUCTURE ***
Type MC07_S_UNIT_COMMAND
    X As MC07_S_COMMAND_DATA
    Y As MC07_S_COMMAND_DATA
    Z As MC07_S_COMMAND_DATA
    A As MC07_S_COMMAND_DATA
    OutPort As MC07_S_OUT_PORT
End Type
    
'*** MPL Function Declarations ***
Declare Function MC07_Environment Lib "Mc07UsbC.dll" (ByVal UnitNo As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_ReadUnitInfo Lib "Mc07UsbC.dll" (ByVal UnitNo As Integer, ByRef psUnitInfo As MC07_S_UNIT_INFO, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UOpen Lib "Mc07UsbC.dll" (ByVal UnitNo As Integer, ByRef phUnit As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UClose Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UClrError Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal AxisSel As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UWExUnitCommMode Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal CommRate As Integer, ByVal RetryCount As Integer, ByVal IoBit As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UWExUnitCommControl Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal ControlSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_URExUnitCommStatus Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_URExUnitCommMode Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByRef pCommRate As Integer, ByRef pRetryCount As Integer, ByRef pIoBit As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRADData Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal Signal As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_IRADData Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByRef psData As MC07_S_AD_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UWDriveIo Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal AxisSel As Long, ByVal IoPortSel As Long, ByRef psUnitCmd As MC07_S_UNIT_COMMAND, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UWRDrive Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal AxisSel As Long, ByRef psUnitCmd As MC07_S_UNIT_COMMAND, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_URStatus1Io Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal AxisSel As Long, ByVal IoPortSel As Long, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_URStatus1PcntIo Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal AxisSel As Long, ByVal IoPortSel As Long, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UPortOut Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal IoPortSel As Long, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UPortOrOut Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal IoPortSel As Long, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UPortAndOut Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal IoPortSel As Long, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_UPortIn Lib "Mc07UsbC.dll" (ByVal hUnit As Long, ByVal IoPortSel As Long, ByRef psInPort As MC07_S_IN_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BOpen Lib "Mc07UsbC.dll" (ByVal UnitNo As Integer, ByVal Axis As Integer, ByRef phDev As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BClose Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_ClrError Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BufWDrive Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psCmdBuf As MC07_S_COMMAND_BUF, ByRef psDataBuf As MC07_S_DATA_BUF, ByVal Count As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_LWDrive Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal Cmd As Integer, ByRef pData As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_LWData Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pData As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_IWDrive Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal Cmd As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_IWData Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_LWDriveBuf Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef CmdDataBuf As MC07_S_COMMAND_DATA, ByVal Count As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BWDriveCommand Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pCmd As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BWDriveData1 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BWDriveData2 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_AllRStatus Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psStsBuf As MC07_S_STATUS_BUF, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRStatus1 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRStatus2 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRStatus3 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRStatus4 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRStatus5 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRStatusBuf Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef StatusBuf As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_LRDrive Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pData As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_IRDrive Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRDriveData1 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BRDriveData2 Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_LWRDrive Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal Cmd As Integer, ByRef pWriteData As Long, ByRef pReadData As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BWaitDriveCommand Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal WaitTime As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BWaitComregNotFull Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal WaitTime As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BIsWait Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pWaitSts As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BBreakWait Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetSpeedRate Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal ResolNo As Integer, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_ReadSpeedRate Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pResolNo As Integer, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_McIncStrCp Lib "Mc07UsbC.dll" (ByVal hDevX As Long, ByVal hDevY As Long, ByVal DrvSpec As Integer, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_McIncCirCp Lib "Mc07UsbC.dll" (ByVal hDevX As Long, ByVal hDevY As Long, ByVal DrvSpec As Integer, ByVal Dir As Integer, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_GetCirShortPulse Lib "Mc07UsbC.dll" (ByVal Dir As Integer, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef ShortPulse As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_GetCirCenterPosition Lib "Mc07UsbC.dll" (ByRef psPassPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pDir As Integer, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_IncFromAbs Lib "Mc07UsbC.dll" (ByVal hDevX As Long, ByVal hDevY As Long, ByRef psAbsPosition As MC07_S_XY_POSITION, ByRef psIncPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_ReadOrgStatus Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef pStatus As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetOrgSpec Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal Spec As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetOrgMarginPulse Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal MarginPulse As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetOrgDelay Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal LimitDelay As Integer, ByVal ScanDelay As Integer, ByVal PulseDelay As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetOrgErrorPulse Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal CScanErrorPulse As Long, ByVal PulseErrorPulse As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetOrgOffsetPulse Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal OffsetPulse As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_SetOrgPresetPulse Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal PresetPulse As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_ReadOrgParam Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psOrgParam As MC07_S_ORG_PARAM, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_ResetOrgFlag Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_Org Lib "Mc07UsbC.dll" (ByVal hDev As Long, ByVal OrgType As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Sub MC07_SetData Lib "Mc07UsbC.dll" (ByVal Data As Long, ByRef psData As MC07_S_DATA)
Declare Function MC07_GetData Lib "Mc07UsbC.dll" (ByRef psData As MC07_S_DATA) As Long
Declare Function MC07_BPortOpen Lib "Mc07UsbC.dll" (ByVal UnitNo As Integer, ByVal IoPort As Integer, ByRef phPort As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BPortClose Lib "Mc07UsbC.dll" (ByVal hPort As Long, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BPortOut Lib "Mc07UsbC.dll" (ByVal hPort As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BPortOrOut Lib "Mc07UsbC.dll" (ByVal hPort As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BPortAndOut Lib "Mc07UsbC.dll" (ByVal hPort As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
Declare Function MC07_BPortIn Lib "Mc07UsbC.dll" (ByVal hPort As Long, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean

